from __future__ import division

class Animation(object):
    
    def __init__(self, duration, frames):
        self.frames = frames
        self.frame_duration = duration / len(frames)
        self.current_frame = 0
        self.interval = 0
        self.loops = 0
        self.callback = None

    def update(self, interval):
        if self.loops != 0:
            self.interval += interval
            if self.interval >= self.frame_duration:
                if self.current_frame == len(self.frames) - 1:
                    self.current_frame = 0
                    self.loops -= 1
                    if self.loops == 0:
                        self.callback()
                else:
                    self.current_frame += 1
                self.interval -= self.frame_duration

    def play(self, loops, callback = None):
        self.current_frame = 0
        self.interval = 0
        self.loops = loops
        self.callback = callback
        
    def get_frame(self):
        return self.frames[self.current_frame]