import pygame
from pygame.locals import *

from datacache import DataCache

class Tile(object):
    
    def __init__(self, image_name, impassable, solid):
        self.datacache = DataCache()
        self.image_name = image_name
        self.impassable = impassable
        self.solid = solid
        self.disturbance = None
        self.rect = self.image.get_rect()
        self.entities = pygame.sprite.Group()

    def add_disturbance(self, disturbance):
        self.disturbances.append(disturbance)
        
    def remove_disturbance(self, disturbance):
        self.disturbances.remove(disturbance)
    
    def add_entity(self, entity):
        self.entities.add(entity)
    
    def remove_entity(self, entity):
        self.entities.remove(entity)
        
    def get_image(self):
        return self.datacache.get_image(self.image_name)
    
    image = property(get_image)
    
    def check_collision(self, entity):
        collisions = []
        if self.impassable:
            collisions.append(self)
        else:
            collisions += pygame.sprite.spritecollide(entity, self.entities, False)
        return collisions
    
    
        
        